#ifndef __KERNEL_VER_H
#define __KERNEL_VER_H

#include <linux/version.h>
#include <linux/cpumask.h>

/* Stream protocol MSS processing changed in 2.6.16 */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,16)
#define SYNCHRONIZE_MSS(sk,tp,opt) ({                                                      \
	        (tp)->ext_header_len = (opt)->opt_flen + (opt)->opt_nflen;                 \
                tcp_sync_mss(sk, (tp)->pmtu_cookie);                                       \
          })
#else
#define SYNCHRONIZE_MSS(sk,tp,opt) ({                                                      \
		(tp)->inet_conn.icsk_ext_hdr_len = (opt)->opt_flen + (opt)->opt_nflen;     \
		tcp_sync_mss(sk, (tp)->inet_conn.icsk_pmtu_cookie);                        \
          })
#endif

/* nf_unregister_queue_rerouter disappeared in 2.6.17 */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,17)
  #define UNREGISTER_REROUTER() nf_unregister_queue_rerouter(AF_INET6)
#else
  #define UNREGISTER_REROUTER() 0
#endif

/* for_each_possible_cpu was introduced in 2.6.16 */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,17)
  #define for_each_possible_cpu(cpu)  for_each_cpu_mask((cpu), cpu_possible_map)
#endif



#endif
