#ifndef __PLA_CONN_H
#define __PLA_CONN_H

#ifdef __KERNEL__
#include <linux/list.h>
#include <linux/types.h>
#else
#include <stdint.h>
#include "fake_linux.h"
#endif
#include "configs.h"

#define PLA_WINDOW_SIZE 128

struct pla_conn
{
	struct list_head list_head;

	uint64_t window_low;            /* Smallest acceptable sequence number */
	int low_index;                  /* Index of the low point */

	char rep_win[PLA_WINDOW_SIZE];
	char key[PLA_HASH_DIGEST_LENGTH];
};

int pla_conn_init(void);
void pla_conn_uninit(void);
int pla_conn_find_add(char *key, uint64_t seqnum, uint32_t c_time);

#endif
