#ifndef _PLA_USERSPACE_CRYPTO_H
#define _PLA_USERSPACE_CRYPTO_H

#include <linux/types.h>

#define IPPROTO_USERSPACE_CRYPTO 15

#define USERSPACE_TYPE_REQUEST 1
#define USERSPACE_TYPE_REPLY   2

struct userspace_crypto_req 
{
	__u8 msg_type;  
	__u8 unused1[3];   /* Padding to 32 bit limit */

	__u32 id_num;
	__u8 task_type;
	__u8 task_code;
	__u8 unused2[2];   /* Padding to 32 bits */

	char task_data[0]; /* Yes, this is legal :) */
};

struct userspace_crypto_reply 
{
	__u8 msg_type;
	__u8 unused1[3]; /* Padding to 32 bit limit */

	__u32 id_num;

	__u8 task_type;
	__u8 task_code;
	__u16 resultdata_len;   /* Length of resultdata */

	char resultdata[0];
};


#endif 
